/*
 * Jsonix is a JavaScript library which allows you to convert between XML
 * and JavaScript object structures.
 *
 * Copyright (C) 2010  Aleksei Valikov, Highsource.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Jsonix.Model.ElementRefPropertyInfo = Jsonix.Class(Jsonix.Model.AbstractElementRefsPropertyInfo, {
	typeInfo : null,
	elementName : null,
	initialize : function(options) {
		Jsonix.Util.Ensure.ensureObject(options);
		Jsonix.Model.AbstractElementRefsPropertyInfo.prototype.initialize.apply(this, [ options ]);
		// TODO Ensure correct argument
		Jsonix.Util.Ensure.ensureObject(options.typeInfo);
		this.typeInfo = options.typeInfo;
		// TODO Ensure correct argument
		if (Jsonix.Util.Type.isObject(options.elementName)) {
			this.elementName = options.elementName;
		} else {
			this.elementName = new Jsonix.XML.QName(this.name);
		}
	},
	getPropertyElementTypeInfo : function(elementName) {
		Jsonix.Util.Ensure.ensureObject(elementName);
		Jsonix.Util.Ensure.ensureString(elementName.localPart);
		var name = Jsonix.XML.QName.fromObject(elementName);

		if (name.key === this.elementName.key) {
			return this;
		} else {
			return null;
		}
	},
	buildStructureElements : function(context, structure) {
		this.buildStructureElementTypeInfos(context, structure, this);
	},
	CLASS_NAME : 'Jsonix.Model.ElementRefPropertyInfo'
});
